//+------------------------------------------------------------------+
//|                                      ErgodicMA.mq4 modified from |
//|                                               mttErgodicMACD.mq4 |
//|                   Copyright  2004-07, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004-07, mietectec"
#property  link      "http://www.forex-tsd.com/indicators-metatrader-4/9950-fx-snipers-indicators-bar.html"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  LimeGreen
#property  indicator_color2  Red
#property  indicator_color3  Yellow
#property  indicator_minimum 0
#property  indicator_maximum 1
#property indicator_width1 4
#property indicator_width2 4
#property indicator_width3 4

// Ergodic
extern string note1 = "--------------------------------------";
extern string note2 = "Ergodic CCI Trigger";
extern int pq =2;
extern int pr = 10;
extern int ps = 5;
extern int trigger =3;
// MA
extern string note3 = "--------------------------------------";
extern string note4 = "Moving Average Type";
extern string note5 = "0=Simple,1=Exponential";
extern string note6 = "2=Smooth,3=Linear Weighted";
extern int MAType = 3;
extern string note7 = "Moving Average Period";
extern int MAPeriod = 3;
extern int MAShift = 0;
extern string note8 = "0=high/low, 1=close/close";
extern int PriceType=0; 
extern string note9 = "Numbers of bars to calculate";
extern int MaxBars=150; 

//---- indicator buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double alertBar;
double prev;
extern bool SoundAlert = true;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
   
//---- drawing settings

   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,4,indicator_color1);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexLabel(0,"BuyZone");
   
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,4,indicator_color2);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexLabel(1,"SellZone");
   
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,4,indicator_color3);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexLabel(2,"NoTradeZone");   

//---- name for DataWindow and indicator subwindow label
   switch(MAType)
     {
      case 1 : short_name="EMA";  break;
      case 2 : short_name="SMMA"; break;
      case 3 : short_name="LWMA"; break;
      default :
         MAType=0;
         short_name="SMA";
     }

   string shortName = "Ergodic "+short_name+" ("+MAPeriod+","+MAShift+","+PriceType+") CCI ("+pq+","+pr+","+ps+","+trigger+")";
   IndicatorShortName(shortName);   
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Calculations                                    |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   if(limit>MaxBars)limit=MaxBars;
 
//---- main loop
   
for(int i=0; i<limit; i++)
{
ExtMapBuffer1[i] = 0; ExtMapBuffer2[i] = 0;
double indErgoMain0 = iCustom(NULL, 0,"FX_Snipers_Ergodic_CCI_Trigger", pq, pr, ps, trigger,0, i);
double indErgoMain1 = iCustom(NULL, 0, "FX_Snipers_Ergodic_CCI_Trigger", pq, pr, ps, trigger,0, i+1);
double indErgoSignal0 = iCustom(NULL, 0, "FX_Snipers_Ergodic_CCI_Trigger",pq, pr, ps, trigger,1, i);
double indErgoSignal1 = iCustom(NULL, 0, "FX_Snipers_Ergodic_CCI_Trigger",pq, pr, ps, trigger,1,i+1);
double indMAMain0 = iCustom(NULL, 0,"FX Sniper's MA", MAType, MAPeriod, MAShift, PriceType, 0, i);
double indMAMain1 = iCustom(NULL, 0, "FX Sniper's MA", MAType, MAPeriod, MAShift, PriceType, 0, i+1);
double indMASignal0 = iCustom(NULL, 0, "FX Sniper's MA", MAType, MAPeriod, MAShift, PriceType, 1, i);
double indMASignal1 = iCustom(NULL, 0, "FX Sniper's MA", MAType, MAPeriod, MAShift, PriceType, 1, i+1);

if (indErgoMain0 > indErgoSignal0 && indMAMain0 > indMASignal0)ExtMapBuffer1[i]=2;
else if (indErgoMain0 < indErgoSignal0 && indMAMain0 < indMASignal0 )ExtMapBuffer2[i]=2;
else ExtMapBuffer3[i]=2;
   if(prev != ExtMapBuffer1[i] && ExtMapBuffer1[i]==2 && SoundAlert == true && Bars>alertBar) {Alert("ErgodicMA Alert changing Up " + Symbol() + " on the " +  Period() + " minute chart.");alertBar = Bars;prev = ExtMapBuffer1[i];}
   if(prev != ExtMapBuffer2[i] && ExtMapBuffer2[i]==2 && SoundAlert == true && Bars>alertBar) {Alert("ErgodicMA Alert changing Down " + Symbol() + " on the " + Period() + " minute chart.");alertBar = Bars;prev = ExtMapBuffer2[i];}
}
return(0);
  }
//+------------------------------------------------------------------+

